﻿using Khronos;
using OpenGL;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GameApp
{
    public partial class MainForm : Form
    {
        DisplayManager _displayManager = new DisplayManager();
        Random _random = new Random(Environment.TickCount);

        public MainForm()
        {
            InitializeComponent();
        }

        private void glControl_ContextCreated(object sender, OpenGL.GlControlEventArgs e)
        {
            GlControl glControl = (GlControl)sender;
            _displayManager.createDisplay(glControl);
        }

        private void glControl_ContextUpdate(object sender, GlControlEventArgs e)
        {
        }

        private void glControl_ContextDestroying(object sender, GlControlEventArgs e)
        {
            _displayManager.closeDisplay();
        }

        private unsafe void glControl_Render(object sender, OpenGL.GlControlEventArgs e)
        {
            Control senderControl = (Control)sender;
            Gl.Viewport(0, 0, senderControl.ClientSize.Width, senderControl.ClientSize.Height);

            int w = 200;
            int h = 200;
            uint* n = stackalloc uint[w * h * 3];

            {
                Gl.ClearColor(0.0f, 0.0f, 1.0f, 1.0f);
                Gl.Clear(ClearBufferMask.ColorBufferBit);

                for (int i = 0; i < (w * h * 3); i++)
                {
                    *(n + i) = (uint)_random.Next(255) * 255u * 255u * 255u;
                }

                IntPtr ptr = new IntPtr(n);
                Gl.DrawPixels(w, h, PixelFormat.Bgr, PixelType.UnsignedInt, ptr);
            }

            _displayManager.updateDisplay();
        }
    }
}
